﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Media;

namespace Wielkanoc
{
    public class IkonaWZasobniku
    {
        private NotifyIcon notifyIcon;
        private System.Windows.Window okno; //WPF

        public IkonaWZasobniku(System.Windows.Window okno)
        {
            string nazwaIkony = "wielkanoc.ico";
            string nazwaAplikacji = Application.ProductName;
            System.Windows.Resources.StreamResourceInfo sri = System.Windows.Application.GetResourceStream(new Uri(@"/" + nazwaAplikacji + ";component/" + nazwaIkony, UriKind.RelativeOrAbsolute));
            Icon ikona = new Icon(sri.Stream);

            notifyIcon = new NotifyIcon();
            notifyIcon.Icon = ikona;
            notifyIcon.Text = "Wielkanoc 2019";
            notifyIcon.Visible = true;

            notifyIcon.DoubleClick += NotifyIcon_DoubleClick;

            //menu
            ContextMenuStrip menu = twórzMenu(okno);
            notifyIcon.ContextMenuStrip = menu;

            //dźwięk
            string ścieżkaPlikuAudio = @"c:\Prywatne\Vermont.mp3";
            if (System.IO.File.Exists(ścieżkaPlikuAudio))
            {
                MediaPlayer mediaPlayer = new MediaPlayer();
                mediaPlayer.Open(new Uri(ścieżkaPlikuAudio, UriKind.RelativeOrAbsolute));
                mediaPlayer.MediaEnded += (s, e) => { mediaPlayer = null; };
                mediaPlayer.Play();
            }
        }

        private static ContextMenuStrip twórzMenu(System.Windows.Window okno)
        {
            ContextMenuStrip menu = new ContextMenuStrip();

            ToolStripMenuItem tsmiUkryj = new ToolStripMenuItem("Ukryj");
            tsmiUkryj.Click += (s, e) => { okno.Hide(); };
            menu.Items.Add(tsmiUkryj);

            ToolStripMenuItem tsmiPokaż = new ToolStripMenuItem("Pokaż");
            tsmiPokaż.Click += (s, e) => { okno.Show(); };
            menu.Items.Add(tsmiPokaż);

            menu.Items.Add(new ToolStripSeparator());

            ToolStripMenuItem tsmiZamknij = new ToolStripMenuItem("Zamknij");
            tsmiZamknij.Click += (s, e) => { okno.Close(); };
            menu.Items.Add(tsmiZamknij);
            return menu;
        }

        private void NotifyIcon_DoubleClick(object sender, EventArgs e)
        {
            notifyIcon.BalloonTipTitle = "Wielkanoc 2019";
            notifyIcon.BalloonTipText = "Wesołych Świąt!";
            notifyIcon.BalloonTipIcon = ToolTipIcon.Info;
            notifyIcon.ShowBalloonTip(1000);
        }

        public void Zniknij()
        {            
            notifyIcon.Visible = false;
            notifyIcon.Dispose();
        }
    }
}
